=== fin/requirements.txt ===
# RadeonOpenCompute/rocm-cmake@cdd0f632b3a65bd4411593bb827eb664e25c80bc --build
nlohmann/json@v3.10.4
