=== debian/control ===
Source: miopen
Section: devel
Homepage: https://github.com/ROCm/MIOpen
Priority: optional
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rocm-team/miopen.git
Vcs-Browser: https://salsa.debian.org/rocm-team/miopen
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
           Xuanteng Huang <xuanteng.huang@outlook.com>,
           Christian Kastner <ckk@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               rocm-cmake,
               clang-17,
               hipcc,
               libhiprtc-builtins5,
               clang-tools-17,
               libclang-common-17-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libbz2-dev,
               librocblas-dev,
               libsqlite3-dev,
               nlohmann-json3-dev,
               pkgconf,
               libhalf-dev,
               zlib1g-dev,
               libgtest-dev,
               libgmock-dev,
               chrpath,
Rules-Requires-Root: no

Package: libmiopen1
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libstdc++-dev,
         libhiprtc-builtins5,
         libclang-common-17-dev,
Description: ROCm library for machine learning primitives - library
 MIOpen is a library for machine learning on AMD GPUs. It provides
 high-performance primitives for a number of operations, including
 convolutions, batch normalization, pooling layers, and softmax layers
 for Recurrent Neural Networks. HIP and OpenCL are both supported as
 programming models.
 .
 This package provides the AMD ROCm MIOpen library.

Package: libmiopen-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libmiopen1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: ROCm library for machine learning primitives - headers
 MIOpen is a library for machine learning on AMD GPUs. It provides
 high-performance primitives for a number of operations, including
 convolutions, batch normalization, pooling layers, and softmax layers
 for Recurrent Neural Networks. HIP and OpenCL are both supported as
 programming models.
 .
 This package provides the AMD ROCm MIOpen development headers.

Package: libmiopen1-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libmiopen1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: ROCm library for machine learning primitives - tests
 MIOpen is a library for machine learning on AMD GPUs. It provides
 high-performance primitives for a number of operations, including
 convolutions, batch normalization, pooling layers, and softmax layers
 for Recurrent Neural Networks. HIP and OpenCL are both supported as
 programming models.
 .
 This package provides the AMD ROCm MIOpen driver and unit tests executable.
