=== debian/watch ===
version=4
opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain,repacksuffix=+dfsg2,dversionmangle=auto" \
    https://api.github.com/repos/ROCm/MIOpen/tags?per_page=100 \
    https://api.github.com/repos/ROCm/MIOpen/tarball/refs/tags/rocm-@ANY_VERSION@
